#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
using namespace std;
int main()
{
  int n;
  cin >> n;
  vector<bool>X(n);
  int nzdA;
  for (int t=0; t<n; t++)
  {
    int n1,n2;
    cin >> n1 >> n2;
    int x, y, prviA;
    for (int i=0; i<n1; i++)
    {
      cin >> x;
      if (i==0) prviA=x;
      if (i==1) nzdA=abs(x-prviA);
      else nzdA=__gcd(abs(x-prviA),nzdA);
    }
    X[t]=1;
    for (int j=0; j<n2; j++)
    {
      cin >> y;
      if (y-prviA%nzdA==0)
      {
        X[t]=0;
        break;
      }
    }
  }
  for (int i=0; i<n; i++)
  {
    cout << X[i];
  }
  return 0;
}